//-----------------------------LICENSE NOTICE------------------------------------
//  This file is part of CPCtelera: An Amstrad CPC Game Engine
//  Copyright (C) 2015 ronaldo / Fremos / Cheesetea / ByteRealms (@FranGallegoBR)
//
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU Lesser General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU Lesser General Public License for more details.
//
//  You should have received a copy of the GNU Lesser General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
//------------------------------------------------------------------------------
#include <cpctelera.h>
#include "personaje.h"
#include "enemigo.h"
#include "enemigo2.h"
#include "casa.h"
#include "casa2.h"
#include "burbuja.h"
#include "tiles.h"
/*
#include "mapa01.h"
*/
#include "heart1.h"
#include "constants.h"
#include "heart2.h"
#include "object.h"
#include "tiles.h"
#include "logo.h"
#include "grupo.h"
#include "key1.h"
#include "key2.h"
#include "door.h"
#include "mapa01.h"
#include "mapa02.h"
#include "mapa03.h"
#include "mapa04.h"
#include "mapa05.h"
#include "marcador.h"

#define ANCHO  80
#define ALTO  200
#define G_maxObjetos 4
#define G_maxCasasEnemigos 1
#define G_maxEnemigos 4 // CAMBIAR POR  EL NUMERO MAXIMO DE enemigos_pantalla en InicializarMapa()
#define ALTO_VIDA  4
#define ALTO_0 16
#define SI 1
#define NUM_MAPAS 9
#define NO 0
#define BORRARP_H G_PERSONAJE_H/4+1
#define BORRARE_H G_ENEMIGO_H/4+1
#define BORRARC_H G_CASA_H/4+1
#define  ORIGEN_MAPA  cpctm_screenPtr(CPCT_VMEM_START, 0, 0)

#define DistanciaVerH 18*4
#define DistanciaVerW 5*4
u8* const mapas[NUM_MAPAS] = { g_map1, g_map2,g_map3, g_map4,g_map5,g_map2,g_map3,g_map4,g_map5};
extern u8 enemigosAlive_asm();
typedef enum EEstados{
      estado_quieto  
   ,  estado_moviendo
   ,  estado_peleando
	,	estado_mirar_derecha
	,	estado_mirar_abajo
	,	estado_mirar_izquierda
	,	estado_mirar_arriba
};

typedef struct
{
  u8 x;
  u8 y;
  u8 px;
  u8 py;
  u8 vida;
  enum EEstados estado;
  u8* sprite;
  enum TypeObject typeObject;
  u8 numObject;
}TPersonaje;

typedef struct{  
u8 vida;    
u8 estado;
u8 x;
u8 y;
u8 px;
u8 py;	
u8* sprite;
u8 danyo;
u8 dis;
u8 ver;
}TEnemigo;

typedef struct{
    u8 x;
    u8 y;
    u8* sprite;
    u8 contador;
    u8 vida;
}TCasaEnemigos;


typedef struct
{
  u8 x;
  u8 y;
  u8 px;
  u8 py;
  u8 mover;
  u8* sprite;
  u8 vida;
	u8 dir;
}TFire;



typedef struct{
   u8 num_mapa;
   u8 enemigos_tam;
   u8 max_enemigos_pantalla;
   u8 max_enemigos_total;
   struct TObjeto objetos[G_maxObjetos];
   TEnemigo enemigos[G_maxEnemigos];
   TCasaEnemigos casa;
}maps;



TPersonaje personaje;
u8* mapa;
TFire fire;
maps Mapas;

cpctm_createTransparentMaskTable(tablatrans, 0x0100, M0, 0);

u8 contador;
u8 es_segundo;
u32 seed;
u8 ruido_movimiento_phf;
u8 contadorTotalEnemigos;
u8 casas_destruidas;
u8 enemigos_matados;

const u8 g_palette2[16] = {
	0, 24, 21, 20, 16, 15, 13, 12,
	11, 9, 6, 4, 3, 2, 1, 26
};

const u8 g_palette3[16] = {
	0, 1, 2, 3, 6, 19, 11, 12, 13, 15,
	16, 23, 20, 24, 22, 26
};


//DETECCIÓN DE COLISIONES

void dibujarCaracterMarcador(u8 caracter, u8 x, u8 y )
{
    cpct_drawSprite (m_tileset[caracter], cpctm_screenPtr(CPCT_VMEM_START,x,y),M_MARCADOR_00_W,M_MARCADOR_00_H);
}

void dibujarMarcador()
{
    u8 aux;
    aux = 0;
    //DIBUJA DE IZQUIERDA A DERECHA A PALO SECO SEGUN EL TILE DE LOS NUMEROS
    //NUMMAPA
    dibujarCaracterMarcador(Mapas.num_mapa+1,ANCHO-4,4);
    dibujarCaracterMarcador(14,ANCHO-6,4); // :
    dibujarCaracterMarcador(12,ANCHO-9,4); // N
    
    //CASAS DESTRUIDAS
    dibujarCaracterMarcador(casas_destruidas,ANCHO-13,4);
    dibujarCaracterMarcador(14,ANCHO-15,4); // :
    dibujarCaracterMarcador(11,ANCHO-17,4); // C
    
    if(enemigos_matados < 10)
    {
        dibujarCaracterMarcador(enemigos_matados,ANCHO-21,4);
        dibujarCaracterMarcador(0,ANCHO-24,4);         
    }
    else if(enemigos_matados > 9 && enemigos_matados < 20)
    {
        aux = (enemigos_matados  - 10);
        dibujarCaracterMarcador(aux,ANCHO-21,4);
        dibujarCaracterMarcador(1,ANCHO-24,4);       
    }
    else if(enemigos_matados > 19 &&  enemigos_matados< 30)
    {
        aux = (enemigos_matados  - 20);
        dibujarCaracterMarcador(aux,ANCHO-21,4);
        dibujarCaracterMarcador(2,ANCHO-24,4);       
    }    
    else if(enemigos_matados > 29 && enemigos_matados < 40)
    {
        aux = (enemigos_matados  - 30);
        dibujarCaracterMarcador(aux,ANCHO-21,4);
        dibujarCaracterMarcador(3,ANCHO-24,4);       
    }
    else if(enemigos_matados > 39 && enemigos_matados < 50)
    {
        aux = (enemigos_matados  - 40);
        dibujarCaracterMarcador(aux,ANCHO-21,4);
        dibujarCaracterMarcador(4,ANCHO-24,4);       
    }  
    else if(enemigos_matados > 49 && enemigos_matados < 60)
    {
        aux = (enemigos_matados  - 50);
        dibujarCaracterMarcador(aux,ANCHO-21,4);
        dibujarCaracterMarcador(5,ANCHO-24,4);       
    }
    else if(enemigos_matados > 59 && enemigos_matados < 70)
    {
        aux = (enemigos_matados  - 60);
        dibujarCaracterMarcador(aux,ANCHO-21,4);
        dibujarCaracterMarcador(6,ANCHO-24,4);       
    } 
    else if(enemigos_matados > 69 && enemigos_matados < 80)
    {
        aux = (enemigos_matados  - 70);
        dibujarCaracterMarcador(aux,ANCHO-21,4);
        dibujarCaracterMarcador(7,ANCHO-24,4);       
    }
    else if(enemigos_matados > 79 && enemigos_matados < 90)
    {
        aux = (enemigos_matados  - 80);
        dibujarCaracterMarcador(aux,ANCHO-21,4);
        dibujarCaracterMarcador(8,ANCHO-24,4);       
    }      
    else if(enemigos_matados > 89 && enemigos_matados < 100)
    {
        aux = (enemigos_matados  - 90);
        dibujarCaracterMarcador(aux,ANCHO-21,4);
        dibujarCaracterMarcador(9,ANCHO-24,4);       
    }      
    else if(enemigos_matados == 100) enemigos_matados = 0; 

    
    //ENEMIGOS MATADOS
    dibujarCaracterMarcador(14,ANCHO-26,4); // :
    dibujarCaracterMarcador(10,ANCHO-29,4); // E
    
}

u8* obtenerTilePtr(u8 x, u8 y) {
   return mapa + (y/4*g_map1_W + x/2);
 }

u8 colisionarMapa(u8 x,u8 y)
{
    if((x >= 0 && x <= ANCHO) && (y >= 0 && y <= ALTO ))
    {
        return *obtenerTilePtr(x,y) != 9 && *obtenerTilePtr(x,y) != 4 && *obtenerTilePtr(x,y) != 14 ;
    }
    else
        return 1;
}

u8 colisionarEnemigo(u8 e,u8 x, u8 y)
{
    return ((x >= Mapas.enemigos[e].x && x <= Mapas.enemigos[e].x + G_ENEMIGO_W) && (y >= Mapas.enemigos[e].y && y <= Mapas.enemigos[e].y + G_ENEMIGO_H));
}

u8 calcularColisionCasa(u8 x, u8 y)
{
    u8 res = 0;
    if(Mapas.casa.vida > 0 
        && (x >= Mapas.casa.x && x <= Mapas.casa.x + G_CASA_W)
        && (y >= Mapas.casa.y && y <= Mapas.casa.y + G_CASA_H)     
            )
        res = 1;
    return res;
}
////

void borrarEnemigo(u8 id)
{
    if(Mapas.enemigos[id].vida > 0)
    {
            u8 w = (G_ENEMIGO_W/2+1) + (Mapas.enemigos[id].px & 1);
            u8 h = BORRARE_H + (Mapas.enemigos[id].py & 3 ? 1 : 0);
            cpct_etm_drawTileBox2x4(Mapas.enemigos[id].px / 2, Mapas.enemigos[id].py/ 4, w, h, g_map1_W, ORIGEN_MAPA, mapa);
    }
}

void ReincializarEnemigo(u8 enemigo)
{
    if(contadorTotalEnemigos <= Mapas.max_enemigos_total &&  Mapas.casa.vida > 0)
    {
        borrarEnemigo(enemigo);
        Mapas.enemigos[enemigo].x = Mapas.enemigos[enemigo].px = Mapas.casa.x;
        Mapas.enemigos[enemigo].y = Mapas.enemigos[enemigo].py = Mapas.casa.y - G_ENEMIGO_H;
        Mapas.enemigos[enemigo].sprite = g_enemigo;
        Mapas.enemigos[enemigo].vida = 100;
        contadorTotalEnemigos++;
    }
    else
    {
        borrarEnemigo(enemigo);
        Mapas.enemigos[enemigo].sprite = g_enemigo;
        Mapas.enemigos[enemigo].vida = 0;        
    }
}

void MatarEnemigos()
{
    u8 i;
    contadorTotalEnemigos = 0;
    for(i = 0; i < Mapas.enemigos_tam;i++)
    {
        borrarEnemigo(i);
        Mapas.enemigos[i].vida = 0;    
        ReincializarEnemigo(i);
    }
}

u8 ColisionarFuego(u8 x,u8 y)
{
    return((x >= fire.x && x <= (fire.x + G_BURBUJA_W)) && (y >= fire.y && y <= (fire.y + G_BURBUJA_H)));
}

u8 manhattanOnlyX(u8 x1, u8 y1, u8 x2, u8 y2)
{
    u8 i = 0;
    if (x1 != x2)
    {
        while (x1 < x2)
        {
            x1++;
            i++;
        }
        while (x1 > x2)
        {
            x1--;
            i++;
        }
    }
    return i;
}

u8 manhattanOnlyY(u8 x1, u8 y1, u8 x2, u8 y2)
{
    u8 i = 0;

    if (y1 != y2)
    {
        while (y1 < y2)
        {
            y1++;
            i++;
        }
        while (y1 > y2)
        {
            y1--;
            i++;
        }
    }
    return i;
}

u8 manhattanY(u8 x1, u8 y1, u8 x2, u8 y2)
{
    u8 i = 0;
    if (y1 != y2)
    {
        while (y1 < y2)
        {
            y1++;
            i++;
        }
        while (y1 > y2)
        {
            y1--;
            i++;
        }
    }
    return i + manhattanOnlyX(x1, y2, x2, y2);
}

u8 manhattanX(u8 x1, u8 y1, u8 x2, u8 y2)
{
    u8 i = 0;
    if (x1 != x2)
    {
        while (x1 < x2)
        {
            x1++;
            i++;
        }
        while (x1 > x2)
        {
            x1--;
            i++;
        }
    }
    return i + manhattanOnlyY(x1, y1, x2, y2);
}

u8 manhattanXY(u8 x1, u8 y1, u8 x2, u8 y2)
{
    u8 min1 = manhattanX(x1, y1, x2, y2);
    u8 min2 = manhattanY(x1, y1, x2, y2);

    return (min1 < min2) ? min1 : min2;
}


void CalcularDanyoCasaEnemigos()
{
    u8 fdis = manhattanXY(Mapas.casa.x,Mapas.casa.y,fire.x,fire.y);
    if( fire.mover==SI && (fdis <200)  && (ColisionarFuego(Mapas.casa.x, Mapas.casa.y)
        || ColisionarFuego(Mapas.casa.x + G_ENEMIGO_W, Mapas.casa.y)
        || ColisionarFuego(Mapas.casa.x, Mapas.casa.y + G_ENEMIGO_H)
        || ColisionarFuego(Mapas.casa.x + G_ENEMIGO_W, Mapas.casa.y + G_ENEMIGO_H) )  )      
    {
            if(
                (fire.dir == 0 && fire.x  + G_CASA_W >= Mapas.casa.x + G_CASA_W)
                || (fire.dir == 1 && fire.y + G_CASA_H >= Mapas.casa.y + G_CASA_H)
                || (fire.dir == 2 && fire.x <= Mapas.casa.x)
                || (fire.dir == 3 && fire.y <= Mapas.casa.y)
               )
            {
                fire.mover = NO;
                borrarFire();
                fire.vida = 0;
                
            }
            Mapas.casa.sprite = g_casa2;        
        if(es_segundo)
        {
            if(Mapas.casa.vida - 25 <= 0)
            {
                if(Mapas.casa.vida > 0) casas_destruidas++;
                Mapas.casa.vida = 0;
                contadorTotalEnemigos = Mapas.max_enemigos_total;
		borrarCasaEnemigos();
            }
            else
            {
               Mapas.casa.vida = Mapas.casa.vida - 25; 
            }
        }
    }
    else
        Mapas.casa.sprite= g_casa;
}

void CalcularDanyoEnemigos()
{
    u8 i;
    u8 fdis = manhattanXY(Mapas.enemigos[i].x,Mapas.enemigos[i].y,fire.x,fire.y);
    for(i = 0; i < Mapas.enemigos_tam;i++)
    {
        if(fire.mover==SI && (fdis < 200) && (ColisionarFuego(Mapas.enemigos[i].x,Mapas.enemigos[i].y)
        || ColisionarFuego(Mapas.enemigos[i].x + G_ENEMIGO_W,Mapas.enemigos[i].y)
        || ColisionarFuego(Mapas.enemigos[i].x ,Mapas.enemigos[i].y + G_ENEMIGO_H)
        || ColisionarFuego(Mapas.enemigos[i].x + G_ENEMIGO_W,Mapas.enemigos[i].y + G_ENEMIGO_H)) )
        {
            if(
                (fire.dir == 0 && fire.x  + G_BURBUJA_W >= Mapas.enemigos[i].x + G_ENEMIGO_W)
                || (fire.dir == 1 && fire.y + G_BURBUJA_H >= Mapas.enemigos[i].y + G_ENEMIGO_H)
                || (fire.dir == 2 && fire.x <= Mapas.enemigos[i].x)
                || (fire.dir == 3 && fire.y <= Mapas.enemigos[i].y)
               )
            {
                fire.mover = NO;
                borrarFire();
                fire.vida = 0;
                
            }
            Mapas.enemigos[i].sprite = g_enemigo2;
            if(es_segundo)
            {
                if(Mapas.enemigos[i].vida - 25 <= 0)
                {
                  borrarEnemigo(i);  
                  Mapas.enemigos[i].vida = 0;
                  enemigos_matados++;
                  ReincializarEnemigo(i);
                }
               else
                Mapas.enemigos[i].vida = Mapas.enemigos[i].vida - 25;
            }
            
            //if(fire.x + G_FIRE_W == Mapas.enemigos[i].x + G_ENEMIGO_W) borrarFire(); ??
        }
        else
            Mapas.enemigos[i].sprite = g_enemigo;
    }
    
}

u8 EstaEnemigoEnArea(u8 x1,u8 x2,u8 y1,u8 y2, u8 enemigo)
{
    u8 res;
    if((Mapas.enemigos[enemigo].x >= x1 && Mapas.enemigos[enemigo].x + G_ENEMIGO_W <= x2 )
            && (Mapas.enemigos[enemigo].y >= y1 && Mapas.enemigos[enemigo].y + G_ENEMIGO_H <= y2  ))
        res = 1;
    else
        res = 0;
    return res;
}


void VerEnemigo(u8 enemigo)
{
    if(Mapas.enemigos[enemigo].dis < 60)
        Mapas.enemigos[enemigo].ver = 1;
    else 
        Mapas.enemigos[enemigo].ver = 0;
}

void ComprobarVerEnemigos()
{
    u8 i;
    for(i = 0; i < Mapas.enemigos_tam; i++)
    {
        if(Mapas.enemigos[i].vida > 0)
        {
            VerEnemigo(i);
        }
    } 
}


u8 ComprobarColisionarEnemigo(u8 e,u8 lado)
{
    u8 res,i;
    u8 edis;
    res = 0;
    for(i = 0; i < Mapas.enemigos_tam;i++)
    {
        if( i != e)
        {     
            if(lado == 0) // izq
            {
                edis = manhattanXY(Mapas.enemigos[i].x,Mapas.enemigos[i].y,Mapas.enemigos[e].x,Mapas.enemigos[e].y);
                if( (edis < 200) &&  (colisionarEnemigo(i,Mapas.enemigos[e].x-1,Mapas.enemigos[e].y+2)
                      //  || colisionarEnemigo(i,Mapas.enemigos[e].x-1,Mapas.enemigos[e].y+4)
                      //  || colisionarEnemigo(i,Mapas.enemigos[e].x-1,Mapas.enemigos[e].y+7)
                        || colisionarEnemigo(i,Mapas.enemigos[e].x-1,Mapas.enemigos[e].y+9)
                      //  || colisionarEnemigo(i,Mapas.enemigos[e].x-1,Mapas.enemigos[e].y+12)
                        || colisionarEnemigo(i,Mapas.enemigos[e].x-1,Mapas.enemigos[e].y+15) )                      
                  )
                {
                    res =1;
                    break;
                }
            }             
            else if(lado == 1) // derecha
            {
                edis = manhattanXY(Mapas.enemigos[i].x,Mapas.enemigos[i].y,Mapas.enemigos[e].x,Mapas.enemigos[e].y);
                if((edis < 200) && (colisionarEnemigo(i,Mapas.enemigos[e].x + G_ENEMIGO_W,Mapas.enemigos[e].y+2)
                   // || colisionarEnemigo(i,Mapas.enemigos[e].x + G_ENEMIGO_W,Mapas.enemigos[e].y+4)
                   // || colisionarEnemigo(i,Mapas.enemigos[e].x + G_ENEMIGO_W,Mapas.enemigos[e].y+7)
                    || colisionarEnemigo(i,Mapas.enemigos[e].x + G_ENEMIGO_W,Mapas.enemigos[e].y+9)
                  //  || colisionarEnemigo(i,Mapas.enemigos[e].x + G_ENEMIGO_W,Mapas.enemigos[e].y+12)             
                    || colisionarEnemigo(i,Mapas.enemigos[e].x + G_ENEMIGO_W,Mapas.enemigos[e].y+15))     
                 )
                {
                    res = 1;
                    break;
                }
            }
            else if(lado == 2) //abajo
            {
                edis = manhattanXY(Mapas.enemigos[i].x,Mapas.enemigos[i].y,Mapas.enemigos[e].x,Mapas.enemigos[e].y);
                if( (edis < 200) && (colisionarEnemigo(i,Mapas.enemigos[e].x,Mapas.enemigos[e].y+G_ENEMIGO_H)
                  // || colisionarEnemigo(i,Mapas.enemigos[e].x+1,Mapas.enemigos[e].y+G_ENEMIGO_H)
                   || colisionarEnemigo(i,Mapas.enemigos[e].x+2,Mapas.enemigos[e].y+G_ENEMIGO_H)
                 //   || colisionarEnemigo(i,Mapas.enemigos[e].x+3,Mapas.enemigos[e].y+G_ENEMIGO_H)
                    || colisionarEnemigo(i,Mapas.enemigos[e].x+4,Mapas.enemigos[e].y+G_ENEMIGO_H) )
                        )
                {
                    res = 1;
                    break;
                }
            }
            else if(lado == 3) // arriba
            {
                edis = manhattanXY(Mapas.enemigos[i].x,Mapas.enemigos[i].y,Mapas.enemigos[e].x,Mapas.enemigos[e].y);
                if((edis < 200) && (colisionarEnemigo(i,Mapas.enemigos[e].x,Mapas.enemigos[e].y)
                  //  || colisionarEnemigo(i,Mapas.enemigos[e].x+1,Mapas.enemigos[e].y)
                    || colisionarEnemigo(i,Mapas.enemigos[e].x+2,Mapas.enemigos[e].y)
                   // || colisionarEnemigo(i,Mapas.enemigos[e].x+3,Mapas.enemigos[e].y)
                    || colisionarEnemigo(i,Mapas.enemigos[e].x+4,Mapas.enemigos[e].y))                           
                  )
                {
                    res = 1;
                    break;
                }               
            }           
        }
    }
    return res;
}


void moverEnemigoIzquierda(u8 idenemigo)
{
	if (
		!colisionarMapa(Mapas.enemigos[idenemigo].x - 1, Mapas.enemigos[idenemigo].y + 2)
		//&& !colisionarMapa(Mapas.enemigos[idenemigo].x - 1, Mapas.enemigos[idenemigo].y + 4)
		//&& !colisionarMapa(Mapas.enemigos[idenemigo].x - 1, Mapas.enemigos[idenemigo].y + 7)
		&& !colisionarMapa(Mapas.enemigos[idenemigo].x - 1, Mapas.enemigos[idenemigo].y + 9)
		//&& !colisionarMapa(Mapas.enemigos[idenemigo].x - 1, Mapas.enemigos[idenemigo].y + 12)
		&& !colisionarMapa(Mapas.enemigos[idenemigo].x - 1, Mapas.enemigos[idenemigo].y + 15)
		&& !calcularColisionCasa(Mapas.enemigos[idenemigo].x-1,Mapas.enemigos[idenemigo].y)
		&& !((Mapas.enemigos[idenemigo].y + G_ENEMIGO_H > personaje.y && Mapas.enemigos[idenemigo].y + G_ENEMIGO_H <= personaje.y + G_PERSONAJE_H && Mapas.enemigos[idenemigo].x == personaje.x + G_PERSONAJE_W)
		|| (Mapas.enemigos[idenemigo].y < personaje.y + G_PERSONAJE_H && Mapas.enemigos[idenemigo].y >= personaje.y && Mapas.enemigos[idenemigo].x == personaje.x + G_PERSONAJE_H))                
                && !calcularColisionCasa(Mapas.enemigos[idenemigo].x-1,Mapas.enemigos[idenemigo].y + G_ENEMIGO_H)                
		&& !ComprobarColisionarEnemigo(idenemigo, 0)
                && Mapas.enemigos[idenemigo].x >= 0


		)
	{
		Mapas.enemigos[idenemigo].x = Mapas.enemigos[idenemigo].x - 1;
	}
}


void moverEnemigoDerecha(u8 idenemigo)
{
	if (
		!colisionarMapa(Mapas.enemigos[idenemigo].x + G_ENEMIGO_W, Mapas.enemigos[idenemigo].y + 2)
		//&& !colisionarMapa(Mapas.enemigos[idenemigo].x + G_ENEMIGO_W, Mapas.enemigos[idenemigo].y + 4)
		//&& !colisionarMapa(Mapas.enemigos[idenemigo].x + G_ENEMIGO_W, Mapas.enemigos[idenemigo].y + 7)
		&& !colisionarMapa(Mapas.enemigos[idenemigo].x + G_ENEMIGO_W, Mapas.enemigos[idenemigo].y + 9)
		//&& !colisionarMapa(Mapas.enemigos[idenemigo].x + G_ENEMIGO_W, Mapas.enemigos[idenemigo].y + 12)
		&& !colisionarMapa(Mapas.enemigos[idenemigo].x + G_ENEMIGO_W, Mapas.enemigos[idenemigo].y + 15)
		&& !calcularColisionCasa(Mapas.enemigos[idenemigo].x+1 + G_ENEMIGO_W,Mapas.enemigos[idenemigo].y)
		&& !((Mapas.enemigos[idenemigo].y + G_ENEMIGO_H > personaje.y && Mapas.enemigos[idenemigo].y + G_ENEMIGO_H <= personaje.y + G_PERSONAJE_H && Mapas.enemigos[idenemigo].x + G_ENEMIGO_W == personaje.x)
		|| (Mapas.enemigos[idenemigo].y < personaje.y + G_PERSONAJE_H && Mapas.enemigos[idenemigo].y >= personaje.y && Mapas.enemigos[idenemigo].x + G_ENEMIGO_W == personaje.x))                
                && !calcularColisionCasa(Mapas.enemigos[idenemigo].x+1 + G_ENEMIGO_W,Mapas.enemigos[idenemigo].y + G_ENEMIGO_H)                
		&& !ComprobarColisionarEnemigo(idenemigo, 1)
		&& Mapas.enemigos[idenemigo].x + G_ENEMIGO_W != ANCHO
		)
	{
		Mapas.enemigos[idenemigo].x = Mapas.enemigos[idenemigo].x + 1;
	}
}

void moverEnemigoAbajo(u8 idenemigo)
{
	if (
		!colisionarMapa(Mapas.enemigos[idenemigo].x, Mapas.enemigos[idenemigo].y + G_ENEMIGO_H)
		//&& !colisionarMapa(Mapas.enemigos[idenemigo].x + 1, Mapas.enemigos[idenemigo].y + G_ENEMIGO_H)
		&& !colisionarMapa(Mapas.enemigos[idenemigo].x + 2, Mapas.enemigos[idenemigo].y + G_ENEMIGO_H)
		//&& !colisionarMapa(Mapas.enemigos[idenemigo].x + 3, Mapas.enemigos[idenemigo].y + G_ENEMIGO_H)
		&& !colisionarMapa(Mapas.enemigos[idenemigo].x + 4, Mapas.enemigos[idenemigo].y + G_ENEMIGO_H)
		&& !calcularColisionCasa(Mapas.enemigos[idenemigo].x,Mapas.enemigos[idenemigo].y + G_ENEMIGO_H +2)
		&& !((Mapas.enemigos[idenemigo].x + G_ENEMIGO_H > personaje.x && Mapas.enemigos[idenemigo].x + G_ENEMIGO_H <= personaje.x + G_PERSONAJE_H && Mapas.enemigos[idenemigo].y + G_ENEMIGO_H == personaje.y)
		|| (Mapas.enemigos[idenemigo].x < personaje.x + G_PERSONAJE_H && Mapas.enemigos[idenemigo].x >= personaje.x && Mapas.enemigos[idenemigo].y + G_ENEMIGO_H == personaje.y))                
                && !calcularColisionCasa(Mapas.enemigos[idenemigo].x + G_ENEMIGO_W,Mapas.enemigos[idenemigo].y + G_ENEMIGO_H+2)                
		&& !ComprobarColisionarEnemigo(idenemigo, 2)
                && Mapas.enemigos[idenemigo].y + G_ENEMIGO_H != ALTO

		)
		Mapas.enemigos[idenemigo].y = Mapas.enemigos[idenemigo].y + 2;
}

void moverEnemigoArriba(u8 idenemigo)
{
	if (
		!colisionarMapa(Mapas.enemigos[idenemigo].x, Mapas.enemigos[idenemigo].y)
		&& !((Mapas.enemigos[idenemigo].x + G_ENEMIGO_H > personaje.x && Mapas.enemigos[idenemigo].x + G_ENEMIGO_H <= personaje.x + G_PERSONAJE_H && Mapas.enemigos[idenemigo].y == personaje.y + G_PERSONAJE_H)
		|| (Mapas.enemigos[idenemigo].x < personaje.x + G_PERSONAJE_H && Mapas.enemigos[idenemigo].x >= personaje.x && Mapas.enemigos[idenemigo].y == personaje.y + G_PERSONAJE_H))                
		//&& !colisionarMapa(Mapas.enemigos[idenemigo].x + 1, Mapas.enemigos[idenemigo].y-2)
		&& !colisionarMapa(Mapas.enemigos[idenemigo].x + 2, Mapas.enemigos[idenemigo].y-2)
		//&& !colisionarMapa(Mapas.enemigos[idenemigo].x + 3, Mapas.enemigos[idenemigo].y-2)
		&& !colisionarMapa(Mapas.enemigos[idenemigo].x + 4, Mapas.enemigos[idenemigo].y-2)
		&& !calcularColisionCasa(Mapas.enemigos[idenemigo].x,Mapas.enemigos[idenemigo].y-2)
                && !calcularColisionCasa(Mapas.enemigos[idenemigo].x,Mapas.enemigos[idenemigo].y + G_ENEMIGO_H-2)                
		&& !ComprobarColisionarEnemigo(idenemigo, 3)
                && Mapas.enemigos[idenemigo].y >= ALTO_0

		)
		Mapas.enemigos[idenemigo].y = Mapas.enemigos[idenemigo].y - 2;
}



void moverEnemigoAleatorio(u8 idenemigo)
{
    u8 random_number = cpct_rand();
    u8 random_number2 = cpct_rand();
    u8 b = random_number % 2;
    u8 c = random_number2 % 2;
    
    if(Mapas.enemigos[idenemigo].vida > 0)
    {
        if(b == 0)
        {
            if(c == 0)
            {
                moverEnemigoIzquierda(idenemigo);
            }
            else if (c == 1)
            {
                moverEnemigoDerecha(idenemigo);
            }
        }
        else if(b == 1)
        {
            if(c == 0)
            {
                moverEnemigoArriba(idenemigo);
            }
            else if (c == 1)
            {
                moverEnemigoAbajo(idenemigo);
            }
        } 
    }
}

void MoverEnemigoPathFinding(u8 enemigo)
{
    u8 movido;
    if(ruido_movimiento_phf == 4)
    {
        moverEnemigoAleatorio(enemigo);
        ruido_movimiento_phf = 0;
    }
    else
    {  
        movido = 0;
        if(personaje.x < Mapas.enemigos[enemigo].x)
        {
            moverEnemigoIzquierda(enemigo);
            movido = 1;
        }
        else if(personaje.x > Mapas.enemigos[enemigo].x)            
        {
            moverEnemigoDerecha(enemigo);
            movido = 1;
        }
        if(personaje.y < Mapas.enemigos[enemigo].y && movido == 0)
        {
            moverEnemigoArriba(enemigo);
        }
        else if(personaje.y > Mapas.enemigos[enemigo].y && movido == 0)
        {
           moverEnemigoAbajo(enemigo);
        }
        else
        {
           moverEnemigoAleatorio(enemigo);
        }
        ruido_movimiento_phf++;
    }
    
}

void moverEnemigo(u8 idenemigo)
{
    if(Mapas.enemigos[idenemigo].sprite != g_enemigo2)
    {
        if(es_segundo && Mapas.enemigos[idenemigo].vida > 0)
        {
           Mapas.enemigos[idenemigo].dis = manhattanXY(personaje.x,personaje.y,Mapas.enemigos[idenemigo].x,Mapas.enemigos[idenemigo].y);
           ComprobarVerEnemigos();

           if(Mapas.enemigos[idenemigo].ver == 1)
           {
              MoverEnemigoPathFinding(idenemigo);
           }
           else  if (Mapas.enemigos[idenemigo].vida > 0)      
           {
               moverEnemigoAleatorio(idenemigo);
           }
        }
    }
}

void moverEnemigos()
{
    u8 i;
    for(i = 0; i < Mapas.enemigos_tam; i++ )
    {
        moverEnemigo(i);
    }
}

void interrupcion() {
   static u8 kk;

   if (++kk == 5) {
      if(contador < 4) /// 0,3 * 3 = 1 APROX (ASI SABEMOS CUANDO OCURRE 1 SEGUNDO)
      {
          contador++;
      }
      else
      {
          contador = 0;
          es_segundo = 1;
      }
      kk = 0;
   }
   else
   {
       moverEnemigos();
       es_segundo = 0;
   }
}
void MostrarCargando()
{
}




void dibujarFire(){
    if(fire.vida == 1)
cpct_drawSpriteMaskedAlignedTable(fire.sprite, cpctm_screenPtr(CPCT_VMEM_START,  fire.x, fire.y), G_BURBUJA_W, G_BURBUJA_H, tablatrans);
}

void borrarFire()
{
    if(fire.vida == 1)
    {
	u8 w=3 + (fire.px & 1);
	u8 h=5 + (fire.py & 3 ? 1 : 0);
	cpct_etm_drawTileBox2x4 (fire.px/2,fire.py/4,w,h,g_map1_W,ORIGEN_MAPA,mapa);
    }
}

void redibujarFire()
{
    borrarFire();
    fire.px=fire.x;
    fire.py=fire.y;
    dibujarFire();
}

u8 creditos(){
	u8* memptr;
	cpct_clearScreen(0);
	cpct_drawSprite(g_grupo, cpctm_screenPtr(CPCT_VMEM_START, 15, 30), G_GRUPO_W, G_GRUPO_H);

	memptr = cpct_getScreenPtr(CPCT_VMEM_START, 0, 60);
	cpct_drawStringM0("____________________", memptr, 10, 0);

	memptr = cpct_getScreenPtr(CPCT_VMEM_START, 25, 80);
	cpct_drawStringM0("EQUIPO:", memptr, 15, 0);

	memptr = cpct_getScreenPtr(CPCT_VMEM_START, 0, 110);
	cpct_drawStringM0("IVAN PASTOR SIMARRO", memptr, 15, 0);

	memptr = cpct_getScreenPtr(CPCT_VMEM_START, 0, 130);
	cpct_drawStringM0("JIMY ANRES PARIS", memptr, 15, 0);

	memptr = cpct_getScreenPtr(CPCT_VMEM_START, 0, 150);
	cpct_drawStringM0("EVTIM TOSHKOV TOSHEV", memptr, 15, 0);

	do{
		cpct_scanKeyboard_f();

		if (cpct_isAnyKeyPressed()){
			if (cpct_isKeyPressed(Key_Esc)){
				cpct_clearScreen(0);
				return 3;
			}
		}
	} while (!cpct_isKeyPressed(Key_Esc));

	return 0;
}

void avanzarMapa() {
   if (Mapas.num_mapa < NUM_MAPAS-1) 
   {
       
      MatarEnemigos(); 
      cpct_clearScreen(0);
      Mapas.num_mapa++; 
      mapa = mapas[Mapas.num_mapa];
      
      inicializarMapa();
      dibujarMapa();
      inicializarCasasEnemigos();
      
   }
   
}


void redibujarPersonaje()
{
  borrarPersonaje();
  personaje.px = personaje.x;
  personaje.py = personaje.y;
  dibujarPersonaje();
}

void dibujarEnemigo(u8 idenemigo)
{
    if(Mapas.enemigos[idenemigo].vida > 0)
    {
        u8* pvmem = cpct_getScreenPtr(CPCT_VMEM_START, Mapas.enemigos[idenemigo].px, Mapas.enemigos[idenemigo].py);
    cpct_drawSprite(Mapas.enemigos[idenemigo].sprite, cpctm_screenPtr(CPCT_VMEM_START, Mapas.enemigos[idenemigo].x, Mapas.enemigos[idenemigo].y), G_ENEMIGO_W, G_ENEMIGO_H);
    cpct_drawSpriteMaskedAlignedTable(Mapas.enemigos[idenemigo].sprite, cpctm_screenPtr(CPCT_VMEM_START, Mapas.enemigos[idenemigo].x, Mapas.enemigos[idenemigo].y), G_ENEMIGO_W, G_ENEMIGO_H, tablatrans);
    }

}

void dibujarEnemigos(u8 mapa)
{
    u8 i;
    for(i = 0; i < G_maxEnemigos; i++)
    {
        dibujarEnemigo(i);
    }
}




void borrarEnemigos()
{
    u8 i;
    for(i = 0; i < G_maxEnemigos; i++)
    {
        borrarEnemigo(i);
    }
}

void redibujarEnemigo(u8 enemigo)
{
    	borrarEnemigo(enemigo);
	Mapas.enemigos[enemigo].px = Mapas.enemigos[enemigo].x;
	Mapas.enemigos[enemigo].py = Mapas.enemigos[enemigo].y;
	dibujarEnemigo(enemigo);
}

void redibujarEnemigos()
{
    u8 i;
    for(i = 0; i < G_maxEnemigos;i++)
    {
        redibujarEnemigo(i);
    }

}

void borrarPersonaje()
{
	u8 w= (G_PERSONAJE_W/2+1) + (personaje.px & 1);
	u8 h= BORRARP_H + (personaje.py & 3 ? 1 : 0);
	cpct_etm_drawTileBox2x4 (personaje.px/2,personaje.py/4,w,h,g_map1_W,ORIGEN_MAPA,mapa);
}

void dibujarPersonaje()
{
      cpct_drawSpriteMaskedAlignedTable(personaje.sprite, cpctm_screenPtr(CPCT_VMEM_START, personaje.x, personaje.y), G_ENEMIGO_W, G_ENEMIGO_H, tablatrans);
}

void dibujarMapa() {
   cpct_etm_drawTilemap2x4(g_map1_W, g_map1_H, ORIGEN_MAPA, mapa);
}

u8 ColisionPersonaje(u8 x,u8 y)
{
    return ((x >= personaje.x && x <= (personaje.x + G_PERSONAJE_W )) && (y >= personaje.y && y <= (personaje.y + G_PERSONAJE_H)));
}



void calcularColisionarEnemigoPersonaje(u8 enemigo) //ATAQUE DE LOS ENEMIGOS, DANYO
{
    if(Mapas.enemigos[enemigo].vida > 0 && Mapas.enemigos[enemigo].dis < 200)
    {
            if(ColisionPersonaje(Mapas.enemigos[enemigo].x,Mapas.enemigos[enemigo].y)
            || ColisionPersonaje(Mapas.enemigos[enemigo].x + G_ENEMIGO_W,Mapas.enemigos[enemigo].y)
            || ColisionPersonaje(Mapas.enemigos[enemigo].x ,Mapas.enemigos[enemigo].y + G_ENEMIGO_H)
            || ColisionPersonaje(Mapas.enemigos[enemigo].x + G_ENEMIGO_W,Mapas.enemigos[enemigo].y + G_ENEMIGO_H)   
            )
        {

            if(es_segundo)
            {
                if(personaje.vida > Mapas.enemigos[enemigo].danyo && personaje.vida > 0 ) 
                {
                    personaje.vida = personaje.vida - Mapas.enemigos[enemigo].danyo ;
                }
                else if(personaje.vida <= Mapas.enemigos[enemigo].danyo  )
                {
                    personaje.vida = 0;
                }
            }
        }
    }
}

void calcularAtaqueEnemigos()
{
    u8 i;
    
    for(i  = 0; i < G_maxEnemigos; i++)
    {
        calcularColisionarEnemigoPersonaje(i);
    }
}

void calcularVida()
{
    if(personaje.vida/4 > 0)
    {
        cpct_drawSolidBox (cpctm_screenPtr(CPCT_VMEM_START,4,ALTO_VIDA), 3, 100/4, 8);
        cpct_drawSolidBox (cpctm_screenPtr(CPCT_VMEM_START,4,ALTO_VIDA), 9, personaje.vida/4, 8);  
    }
}


void dibujarCasaEnemigos()
{
    if(Mapas.casa.vida > 0)
    {
        u8* pvmem;
        pvmem = cpct_getScreenPtr(CPCT_VMEM_START, Mapas.casa.x, Mapas.casa.y);
        cpct_drawSpriteMaskedAlignedTable(Mapas.casa.sprite, cpctm_screenPtr(CPCT_VMEM_START, Mapas.casa.x, Mapas.casa.y), G_CASA_W, G_CASA_H, tablatrans);
    }
}

void borrarCasaEnemigos()
{
    	u8 w= (G_CASA_W/2+1) + (personaje.px & 1);
	u8 h= BORRARC_H + (personaje.py & 3 ? 1 : 0);
	cpct_etm_drawTileBox2x4 (Mapas.casa.x/2,Mapas.casa.y/4,w,h,g_map1_W,ORIGEN_MAPA,mapa);
}

void redibujarCasaEnemigos()
{
       // borrarCasaEnemigos();
	dibujarCasaEnemigos();    
}



void inicializarCasasEnemigos()
{
    if(Mapas.num_mapa == 0)
    {
        Mapas.casa.x = 50;
        Mapas.casa.y = 120;     
    }
    else if(Mapas.num_mapa == 1)
    {
        Mapas.casa.x = 50;
        Mapas.casa.y = 100;   
    }
    else if(Mapas.num_mapa == 2)
    {
        Mapas.casa.x = 30;
        Mapas.casa.y = 50; 
        
    }
    else if (Mapas.num_mapa == 3)
    {
            Mapas.casa.x = 50;
            Mapas.casa.y = 130;

    }
    else if (Mapas.num_mapa == 4)
    {
            Mapas.casa.x = 50;
            Mapas.casa.y = 140;

    }    
    else if (Mapas.num_mapa == 5)
    {
            Mapas.casa.x = 50;
            Mapas.casa.y = 100;

    }   
    else if (Mapas.num_mapa == 6)
    {
            Mapas.casa.x = 40;
            Mapas.casa.y = 45;

    }  
    else if (Mapas.num_mapa == 7)
    {
            Mapas.casa.x = 50;
            Mapas.casa.y = 130;

    }    
    else if (Mapas.num_mapa == 8)
    {
            Mapas.casa.x = 50;
            Mapas.casa.y = 140;

    }    
        Mapas.casa.contador = 0;
        //Mapas.casas_tam = 1;
        Mapas.casa.sprite = g_casa;
        Mapas.casa.vida = 100;
        dibujarCasaEnemigos();
    
}

void GenerarEnemigo()
{


            if( Mapas.enemigos_tam <= Mapas.max_enemigos_pantalla && Mapas.casa.vida > 0)
            {            
                if(Mapas.casa.contador == 0)
                {
                Mapas.enemigos[Mapas.enemigos_tam].x = Mapas.enemigos[Mapas.enemigos_tam].px  =Mapas.casa.x; 
                Mapas.enemigos[Mapas.enemigos_tam].y = Mapas.enemigos[Mapas.enemigos_tam].py  =  Mapas.casa.y - G_ENEMIGO_H - 5; 
                }
                else if(Mapas.casa.contador == 1)
                {
                Mapas.enemigos[Mapas.enemigos_tam].x = Mapas.enemigos[Mapas.enemigos_tam].px   =Mapas.casa.x + G_ENEMIGO_W +5; 
                Mapas.enemigos[Mapas.enemigos_tam].y = Mapas.enemigos[Mapas.enemigos_tam].py  =  Mapas.casa.y;                               
                }
                else if(Mapas.casa.contador == 2)
                {
                Mapas.enemigos[Mapas.enemigos_tam].x = Mapas.enemigos[Mapas.enemigos_tam].px   =Mapas.casa.x; 
                Mapas.enemigos[Mapas.enemigos_tam].y = Mapas.enemigos[Mapas.enemigos_tam].py  =  Mapas.casa.y + G_ENEMIGO_H +5;              
                }
                else if(Mapas.casa.contador == 4)
                {
                Mapas.enemigos[Mapas.enemigos_tam].x = Mapas.enemigos[Mapas.enemigos_tam].px  =Mapas.casa.x - G_ENEMIGO_W - 5;
                Mapas.enemigos[Mapas.enemigos_tam].y = Mapas.enemigos[Mapas.enemigos_tam].py  =  Mapas.casa.y;           
                }
                Mapas.enemigos[Mapas.enemigos_tam].sprite = g_enemigo; 
                Mapas.enemigos[Mapas.enemigos_tam].danyo = 25;  
                Mapas.enemigos[Mapas.enemigos_tam].vida = 100;
                Mapas.enemigos[Mapas.enemigos_tam].ver = 0;
                if(Mapas.enemigos[Mapas.enemigos_tam].x == 0 && Mapas.enemigos[Mapas.enemigos_tam].y == 0  )  
                {
                    Mapas.enemigos[Mapas.enemigos_tam].x = Mapas.casa.x;
                    Mapas.enemigos[Mapas.enemigos_tam].y = Mapas.casa.y - G_ENEMIGO_H;
                }                
                Mapas.enemigos_tam++;
                Mapas.casa.contador++;
                if(Mapas.casa.contador == 4) Mapas.casa.contador = 0;
                
            }
       
    
}




void inicializarObjetoMapa(){
   u8 j;
	u8 posX;
	u8 posY;

		posX=0;
		posY=1;
		for(j=0;j<G_maxObjetos;j++){
				
			if((*(g_MapasObjetos+(Mapas.num_mapa*8+posX)))==0){
				Mapas.objetos[j].alive=NO;
			}else{
				if(j==2){
					Mapas.objetos[j].alive=NO;
					Mapas.objetos[j].cambio=3;
				}else {
					Mapas.objetos[j].alive=SI;
					Mapas.objetos[j].cambio=NO;
				}
				Mapas.objetos[j].x=*(g_MapasObjetos+(Mapas.num_mapa*8+posX));
				Mapas.objetos[j].y=*(g_MapasObjetos+(Mapas.num_mapa*8+posY));
				
			}
					
			posX=posY+1;
			posY=posX+1;
		}
			
	/*	if(personaje.numObject>Mapas.num_mapa){
			Mapas.objetos[2].alive=NO;
		}*/
}



void inicializacionIniObjetos(){
Mapas.objetos[0].sprite=g_heart1;
	Mapas.objetos[0].w=G_HEART2_W;
	Mapas.objetos[0].h=G_HEART2_H;

	Mapas.objetos[1].sprite=g_heart2;
	Mapas.objetos[1].w=G_HEART2_W;
	Mapas.objetos[1].h=G_HEART2_H;



	Mapas.objetos[2].sprite=g_key1;
	Mapas.objetos[2].w=G_KEY1_W;
	Mapas.objetos[2].h=G_KEY1_H;


	Mapas.objetos[3].sprite=g_door;
	Mapas.objetos[3].w=G_DOOR_W;
	Mapas.objetos[3].h=G_DOOR_H;
}


void inicializarMapa(){
    
    if(Mapas.num_mapa == 0)
    {
        Mapas.max_enemigos_pantalla = 1;
        Mapas.max_enemigos_total = 1;
        personaje.x = 2;
        personaje.y = 16;
    }
    else if(Mapas.num_mapa == 1)
    {
        Mapas.max_enemigos_pantalla = 2;
        Mapas.max_enemigos_total = 3;
		personaje.x = 2;
		personaje.y = 16;
		
    }
    else if(Mapas.num_mapa == 2)
    {
        Mapas.max_enemigos_pantalla = 2;
        Mapas.max_enemigos_total =4;
		personaje.x = 2;
		personaje.y = 20;
    }
    else if (Mapas.num_mapa == 3)
    {
		Mapas.max_enemigos_pantalla = 3;
		Mapas.max_enemigos_total = 5;
		personaje.x = 2;
		personaje.y = 33;
    }
    else if (Mapas.num_mapa == 4)
    {
		Mapas.max_enemigos_pantalla = 3;
		Mapas.max_enemigos_total = 6;
		personaje.x = 8;
		personaje.y = 33;
    } 
    
    else if(Mapas.num_mapa == 5)
    {
        Mapas.max_enemigos_pantalla = 4;
        Mapas.max_enemigos_total = 8;
		personaje.x = 2;
		personaje.y = 16;
		
    }
    else if(Mapas.num_mapa == 6)
    {
        Mapas.max_enemigos_pantalla = 4;
        Mapas.max_enemigos_total =8;
		personaje.x = 2;
		personaje.y = 20;
    }
    else if (Mapas.num_mapa == 7)
    {
		Mapas.max_enemigos_pantalla = 4;
		Mapas.max_enemigos_total = 8;
		personaje.x = 2;
		personaje.y = 33;
    }
    else if (Mapas.num_mapa == 8)
    {
		Mapas.max_enemigos_pantalla = 4;
		Mapas.max_enemigos_total = 8;
		personaje.x = 8;
		personaje.y = 33;
    }
        Mapas.enemigos_tam = 0; //SE INICIALIZA

	inicializarObjetoMapa();
   inicializarCasasEnemigos();    
}



void inicializar()
{
  MostrarCargando();  
  contador = 0;
  ruido_movimiento_phf = 0;
  es_segundo = 0;
  cpct_disableFirmware();
  cpct_setVideoMode(0);
  cpct_setBorder(HW_BLACK);
  personaje.vida = 100;
  personaje.estado = estado_quieto;
  personaje.sprite=g_personaje;
  contadorTotalEnemigos = 0;
inicializacionIniObjetos();
Mapas.num_mapa=0;
  cpct_setPalette(g_palette, 16);
  mapa = g_map1;
  cpct_etm_setTileset2x4(g_tileset);
  fire.sprite=g_burbuja;
  fire.mover= NO;
  fire.vida = 1;
  inicializarMapa();
  dibujarMapa();
  cpct_setInterruptHandler(interrupcion);
}



/////////////////////////////////////////////////

void mover_derecha()
{
	if (
		!colisionarMapa(personaje.x + G_PERSONAJE_W, personaje.y + 2)
		//&& !colisionarMapa(personaje.x + G_PERSONAJE_W, personaje.y + 4)
		//&& !colisionarMapa(personaje.x + G_PERSONAJE_W, personaje.y + 7)
		&& !colisionarMapa(personaje.x + G_PERSONAJE_W, personaje.y + 9)
		//&& !colisionarMapa(personaje.x + G_PERSONAJE_W, personaje.y + 12)
		&& !colisionarMapa(personaje.x + G_PERSONAJE_W, personaje.y + 15)
		&& !calcularColisionCasa(personaje.x+1 + G_PERSONAJE_W,personaje.y)
                && !calcularColisionCasa(personaje.x+1 + G_PERSONAJE_W,personaje.y + G_PERSONAJE_H)
		&& personaje.x + G_PERSONAJE_W != ANCHO
		)
	{
		personaje.x++;
		personaje.estado = estado_mirar_derecha;
	}
}

void mover_izquierda()
{
	if (
		!colisionarMapa(personaje.x - 1, personaje.y + 2)
		//&& !colisionarMapa(personaje.x - 1, personaje.y + 4)
		//&& !colisionarMapa(personaje.x - 1, personaje.y + 7)
		&& !colisionarMapa(personaje.x - 1, personaje.y + 9)
		//&& !colisionarMapa(personaje.x - 1, personaje.y + 12)
		&& !colisionarMapa(personaje.x - 1, personaje.y + 15)
		&& !calcularColisionCasa(personaje.x-1,personaje.y)
                && !calcularColisionCasa(personaje.x-1,personaje.y + G_PERSONAJE_H)
                && personaje.x >= 0                
		)
	{
		personaje.x--;
		personaje.estado = estado_mirar_izquierda;
	}
}

void mover_arriba()
{
	if (
		!colisionarMapa(personaje.x, personaje.y-1)
		//&& !colisionarMapa(personaje.x + 1, personaje.y-1)
		&& !colisionarMapa(personaje.x + 2, personaje.y-1)
		//&& !colisionarMapa(personaje.x + 3, personaje.y-1)
		&& !colisionarMapa(personaje.x + 4, personaje.y-1)
		&& !calcularColisionCasa(personaje.x,personaje.y-2)
                && !calcularColisionCasa(personaje.x,personaje.y + G_PERSONAJE_H-2)
                && personaje.y >= ALTO_0


		)
	{
		personaje.y = personaje.y - 2;
		personaje.estado = estado_mirar_arriba;
	}
}

void mover_abajo()
{
	if (
		!colisionarMapa(personaje.x, personaje.y + G_PERSONAJE_H)
		//&& !colisionarMapa(personaje.x + 1, personaje.y + G_PERSONAJE_H)
		&& !colisionarMapa(personaje.x + 2, personaje.y + G_PERSONAJE_H)
		//&& !colisionarMapa(personaje.x + 3, personaje.y + G_PERSONAJE_H)
		&& !colisionarMapa(personaje.x + 4, personaje.y + G_PERSONAJE_H)
		&& !calcularColisionCasa(personaje.x,personaje.y + G_PERSONAJE_H +2)
                && !calcularColisionCasa(personaje.x + G_PERSONAJE_W,personaje.y + G_PERSONAJE_H +2)
                && personaje.x != ALTO
		)
	{
		personaje.y = personaje.y + 2;
		personaje.estado = estado_mirar_abajo;
	}
}


void moverFireDerecha()
{
    if(fire.vida == 1) fire.x=fire.x  + 1;
}

void moverFireIzquierda()
{
    if(fire.vida == 1) fire.x=fire.x - 1;
}

void moverFireArriba()
{
    if(fire.vida == 1) fire.y=fire.y  - 2;
}

void moverFireAbajo()
{
    if(fire.vida == 1) fire.y= fire.y + 2;
}



void MoverFire()
{
    u8 colision;
    colision = 0;
    if(fire.vida == 1)
    {
        fire.mover = SI;
        if(fire.dir == 0)
        {
            if( (!colisionarMapa(fire.x -1 + G_BURBUJA_W,fire.y+2))
                && (!colisionarMapa(fire.x -1 +G_BURBUJA_W,fire.y+G_BURBUJA_H-2)))
            moverFireDerecha();
            else colision = 1;
        }
        else if(fire.dir == 1)
        {
            if(  (!colisionarMapa(fire.x-1,fire.y + G_BURBUJA_H -2)) 
                && (!colisionarMapa(fire.x-1+G_BURBUJA_W,fire.y + G_BURBUJA_H -2)))
            moverFireAbajo();
            else colision = 1;
        }
        else if(fire.dir == 2)
        {
            if(  (!colisionarMapa(fire.x+1,fire.y+2)) 
                && (!colisionarMapa(fire.x+1,fire.y + G_BURBUJA_H-2)))            
            moverFireIzquierda();
            else colision = 1;
        }
        else if(fire.dir == 3)
        {
            if(  (!colisionarMapa(fire.x+1,fire.y+2)) 
                && (!colisionarMapa(fire.x+1+G_BURBUJA_W,fire.y+2)))            
            moverFireArriba();
            else colision = 1;
        }
        redibujarFire();  
        if(colision ||  fire.x <= 0 || fire.x + G_BURBUJA_W  > ANCHO+4 ||   fire.y < ALTO_0 || fire.y  + G_BURBUJA_H > ALTO )
        {
            fire.mover = NO;
            borrarFire();
            fire.vida = 0;
        }
        //colision con personajes se calcula y se asigna cuando un personaje siente danyo
    }
}

void reiniciarFire()
{
    if (personaje.estado==estado_mirar_derecha) fire.dir=0;
    else if (personaje.estado==estado_mirar_abajo)fire.dir=1;
    else if (personaje.estado==estado_mirar_izquierda)fire.dir=2;
    else if (personaje.estado==estado_mirar_arriba)fire.dir=3;    
    fire.x = personaje.x;
    fire.y = personaje.y; 
    fire.vida = 1;
    fire.mover = 0;
    MoverFire(); 
}

void borrarObjetos(){
	u8 i;


	for(i=0;i<G_maxObjetos;i++){
		Mapas.objetos[i].alive=NO;
	}
}

void actualizarObjeto(u8 i) {

		if(i==0){
				if(personaje.vida<51){
					personaje.vida=personaje.vida+50;
				}else{
					personaje.vida=100;
				}
				Mapas.objetos[i].alive=NO;

			}else if(i==1){
				if(personaje.vida<86){
					personaje.vida=personaje.vida+25;
				}else{
					personaje.vida=100;
				}
				Mapas.objetos[i].alive=NO;
			}else if(i==2){
				personaje.typeObject=2;
				//personaje.numObject=Mapas.objetos[i].numObject;
				Mapas.objetos[i].alive=NO;
			}else if(i==3){
				if(personaje.typeObject==2){
					personaje.typeObject=0;
					//personaje.numObject=Mapas.num_mapa+1;
                                        if(Mapas.num_mapa != 8)
					avanzarMapa();
                                        else
                                        {
                                            personaje.vida = 0;
                                            creditos();
                                        }
				//	personaje.numObject=Mapas.num_mapa;
				//	borrarObjetos();
				}/*else if(personaje.numObject>Mapas.num_mapa){
					avanzarMapa();
				}*/

			}
}

void actualizarObjetos(){
 	u8 i;

	for(i=0;i<G_maxObjetos;i++){

		if(Mapas.objetos[i].alive){
			if(personaje.x<=Mapas.objetos[i].x ){
					if((personaje.x+G_PERSONAJE_W) > Mapas.objetos[i].x){
							if(personaje.y<=Mapas.objetos[i].y){
									if(personaje.y+ G_PERSONAJE_H>Mapas.objetos[i].y){
										 actualizarObjeto(i);
									}
								}
					}
			}else if(personaje.x< (Mapas.objetos[i].x + Mapas.objetos[i].w)){
				if(personaje.y<=Mapas.objetos[i].y){
					if((personaje.y+ G_PERSONAJE_H)> Mapas.objetos[i].y){
						actualizarObjeto(i);
					}
				}
			}
		}
	}

}
void comprobarTeclado(){
cpct_scanKeyboard_if();

  if(cpct_isAnyKeyPressed())
      {
        if(cpct_isKeyPressed(Key_A))
        {
          mover_izquierda();
			 actualizarObjetos();
			 if(cpct_isKeyPressed(Key_Space)){
	  			reiniciarFire();
			 }
        }
        else if(cpct_isKeyPressed(Key_D))
        {
          mover_derecha();
			 actualizarObjetos();
			 if(cpct_isKeyPressed(Key_Space)){
	  			reiniciarFire();
			 }
        }

        else if(cpct_isKeyPressed(Key_W))
        {
          mover_arriba();
			 actualizarObjetos();
			 if(cpct_isKeyPressed(Key_Space)){
	  			reiniciarFire();
			 }
        }

        else if(cpct_isKeyPressed(Key_S))
        {
          mover_abajo();
			 actualizarObjetos();
				if(cpct_isKeyPressed(Key_Space)){
                                    reiniciarFire();
				}
        }else if(cpct_isKeyPressed(Key_Space))
        {
            reiniciarFire();
        }    
      }  
}

void borrarObjeto(u8 i){
	u8 w=(Mapas.objetos[i].w/2+1) + (Mapas.objetos[i].x & 1);
	u8 h=(Mapas.objetos[i].h/4+1) + (Mapas.objetos[i].y & 3 ? 1 : 0);
	cpct_etm_drawTileBox2x4 (Mapas.objetos[i].x/2,Mapas.objetos[i].y/4,w,h,g_map1_W,ORIGEN_MAPA,mapa);

}

void comprobarObjetos() {
	u8 i;
	for(i=0;i <G_maxObjetos;i++){
		//if(){
				if(Mapas.objetos[i].alive){
					cpct_drawSpriteMaskedAlignedTable(Mapas.objetos[i].sprite, cpctm_screenPtr(CPCT_VMEM_START, Mapas.objetos[i].x, Mapas.objetos[i].y), Mapas.objetos[i].w, Mapas.objetos[i].h, tablatrans);
				}else {
					if(Mapas.objetos[i].cambio==0){
						borrarObjeto(i);
						Mapas.objetos[i].cambio=SI;
					}else if(i==2){
						/*if(Mapas.casa.vida==0){
							if(Mapas.enemigos_tam==0){
								Mapas.objetos[2].alive=SI;
							Mapas.objetos[2].cambio=NO;
							}
						}else if(Mapas.objetos[2].cambio==3 && Mapas.enemigos_tam==0){
							Mapas.objetos[2].alive=SI;
							Mapas.objetos[2].cambio=NO;
						}*/
						if(Mapas.objetos[2].cambio==3 && enemigosAlive_asm()==0){
							Mapas.objetos[2].alive=SI;
							Mapas.objetos[2].cambio=NO;
						}
						
					}
				}
		}
}

void MostrarHasMuerto()
{
	u8* memptr;
	memptr = cpct_getScreenPtr(CPCT_VMEM_START, 19, 20);
	cpct_drawStringM0("YOU DIED!", memptr, 10, 0);
	memptr = cpct_getScreenPtr(CPCT_VMEM_START, 0, 160);
	cpct_drawStringM0("SPACE KEY:PLAY AGAIN", memptr, 15, 0);      
        memptr = cpct_getScreenPtr(CPCT_VMEM_START, 0, 172);
        cpct_drawStringM0("ESC : RETURN MENU", memptr, 15, 0);      
}



//Menú
u8 menu(){
	u8* memptr;

	cpct_drawSprite(g_logo, cpctm_screenPtr(CPCT_VMEM_START, 10, 30), G_LOGO_W, G_LOGO_H);



	memptr = cpct_getScreenPtr(CPCT_VMEM_START, 19, 80);
	cpct_drawStringM0("1.Play", memptr, 15, 0);

	memptr = cpct_getScreenPtr(CPCT_VMEM_START, 19, 100);
	cpct_drawStringM0("2.Controls", memptr, 15, 0);

	memptr = cpct_getScreenPtr(CPCT_VMEM_START, 19, 120);
	cpct_drawStringM0("3.Credits", memptr, 15, 0);

	cpct_scanKeyboard_f();

	if (cpct_isKeyPressed(Key_1)){
		return 1;
	}
	else if (cpct_isKeyPressed(Key_2)){
		return 2;
	}
	else if (cpct_isKeyPressed(Key_3)){
		return 3;
	}
	return 0;
}

u8 controles(){
	u8* memptr;
	cpct_clearScreen(0);
	memptr = cpct_getScreenPtr(CPCT_VMEM_START, 19, 20);
	cpct_drawStringM0("CONTROLS:", memptr, 10, 0);

	memptr = cpct_getScreenPtr(CPCT_VMEM_START, 15, 60);
	cpct_drawStringM0("W: Move up.", memptr, 15, 0);

	memptr = cpct_getScreenPtr(CPCT_VMEM_START, 15, 80);
	cpct_drawStringM0("S: Mover down.", memptr, 15, 0);

	memptr = cpct_getScreenPtr(CPCT_VMEM_START, 15, 100);
	cpct_drawStringM0("A: Mover left", memptr, 15, 0);

	memptr = cpct_getScreenPtr(CPCT_VMEM_START, 15, 120);
	cpct_drawStringM0("D: Mover right", memptr, 15, 0);

	memptr = cpct_getScreenPtr(CPCT_VMEM_START, 15, 140);
	cpct_drawStringM0("Space: Shoot", memptr, 15, 0);

	memptr = cpct_getScreenPtr(CPCT_VMEM_START, 15, 160);
	cpct_drawStringM0("ESC: Back", memptr, 15, 0);

	do{
		cpct_scanKeyboard_f();

		if (cpct_isAnyKeyPressed()){
			if (cpct_isKeyPressed(Key_Esc)){
				cpct_clearScreen(0);
				return 2;
			}
		}
	} while (!cpct_isKeyPressed(Key_Esc));

	return 0;
}

void juego()
{
    u8 fin;
    fin = 0;
    
    
   // Loop forever
   while (!fin)
   {
       
            MoverFire();
            calcularAtaqueEnemigos();
            CalcularDanyoEnemigos();
            CalcularDanyoCasaEnemigos();
            calcularVida();
           if(es_segundo)
           {
            ComprobarVerEnemigos();
            }
            if(personaje.vida == 0)
            {
                fin = 1;
            }
            else
            {      
                comprobarTeclado();


                if(Mapas.enemigos_tam < Mapas.max_enemigos_pantalla)
                {
                     GenerarEnemigo();  
                }
                comprobarObjetos();
                cpct_waitVSYNC();
                redibujarPersonaje();
                redibujarEnemigos();
                redibujarCasaEnemigos();
                dibujarMarcador();
            }
       
   }    
}

u8 jugar(){
    u8 uno;
    Mapas.num_mapa = 0;
    casas_destruidas = 0;
    enemigos_matados = 0;
    uno = 0;
    inicializar();
    dibujarPersonaje();
    while(1)
    {

        if(personaje.vida > 0)
        {
            juego(); 
        }
         if(personaje.vida == 0)
        {
             if(uno == 0)
             {
                cpct_clearScreen(0); 
                MostrarHasMuerto();
                uno++;
             }
            cpct_scanKeyboard();
            if(cpct_isKeyPressed(Key_Space))
            {
                //Reinicialización
                MatarEnemigos();
                inicializar();
		Mapas.num_mapa=0;
                enemigos_matados = 0;
                casas_destruidas = 0;
                inicializarMapa();
                dibujarPersonaje();
                uno = 0;

            }
            else if (cpct_isKeyPressed(Key_Esc)){
                    cpct_clearScreen(0);
                    menu();
                    uno = 0;
                    return 0;
            }            
        }


        
        
    }

}

void main(void) {
	u8 men, fin;
	u8* pvmem; 
	
	seed = 4004;
	cpct_disableFirmware();
	cpct_setVideoMode(0);
	cpct_fw2hw(g_palette2, 16);
	cpct_setPalette(g_palette2, 16);

	cpct_clearScreen(0);
	cpct_setBorder(HW_BLACK);
	while (1){
		men = menu();
		switch (men){
		case 1:
			cpct_fw2hw(g_palette3, 16);
			cpct_setPalette(g_palette3, 16);
			jugar();

			break;
		case 2:
			cpct_setPalette(g_palette2, 16);
			controles();
			break;

		case 3:
			cpct_setPalette(g_palette2, 16);
			creditos();
			break;
		}
	}


}
